<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\ItempermintaanbarangService;
use App\Http\Validators\ItempermintaanbarangValidator;
use App\Http\Services\ItemService;
use App\Http\Services\PermintaanbarangService;

class ItempermintaanbarangController extends BaseController
{
    protected $baseService;
    protected $validator;
    private $item;
    private $permintaanbarang;

    /**
     * Itempermintaanbarang constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new ItempermintaanbarangService();
        $this->validator = new ItempermintaanbarangValidator();
        $this->item = new ItemService();
        $this->permintaanbarang = new PermintaanbarangService();

    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $this->validator->beforeInsert($request->all());
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->store($request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/itempermintaanbarang")->with("successMessages", "Data has been created");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function paging(Request $request)
    {
        $this->data["header"] = ["id" => "id"
            , "itemId" => "itemId"
            , "prNumber" => "prNumber"
            , "needBy" => "needBy"
            , "quantity" => "quantity"
            , "satuan" => "satuan"
        ];
        $this->data["criteria"] = ["id" => "id"
            , "itemId" => "itemId"
            , "prNumber" => "prNumber"
            , "needBy" => "needBy"
            , "quantity" => "quantity"
            , "satuan" => "satuan"
        ];
        $this->data["ordering"] = ["id:asc" => "id"
            , "itemId:asc" => "itemId"
            , "prNumber:asc" => "prNumber"
            , "needBy:asc" => "needBy"
            , "quantity:asc" => "quantity"
            , "satuan:asc" => "satuan"
        ];
        $this->data["itempermintaanbarangs"] = $this->baseService->paging($request->all());
        return view("modules.itempermintaanbarang.itempermintaanbarang_index", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit($id)
    {
        $this->data["items"] = $this->item->index();
        $this->data["permintaanbarangs"] = $this->permintaanbarang->index();
        $this->data["itempermintaanbarang"] = $this->baseService->show($id);
        return view("modules.itempermintaanbarang.itempermintaanbarang_edit", $this->data);
    }


    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function update(Request $request, $id)
    {
        $this->validator->beforeUpdate($request->all(), $id);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->update($id, $request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/itempermintaanbarang")->with("successMessages", "Data has been updated");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create()
    {
        $this->data["items"] = $this->item->index();
        $this->data["permintaanbarangs"] = $this->permintaanbarang->index();
        return view("modules.itempermintaanbarang.itempermintaanbarang_create", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show($id)
    {
        $this->data["items"] = $this->item->index();
        $this->data["permintaanbarangs"] = $this->permintaanbarang->index();
        $this->data["itempermintaanbarang"] = $this->baseService->show($id);
        return view("modules.itempermintaanbarang.itempermintaanbarang_show", $this->data);
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }


}